#! /bin/bash

#set -e

InstallPath=$(dirname $(readlink -f "$0"));

stop360sd()
{

    pid=`pgrep -f "start360sd_safed"`
    if [ ! -z "$pid" ]; then
        kill -9 $pid
    fi

    pid=`pgrep -f "start360sd"`
    if [ ! -z "$pid" ]; then
        echo `ps -eo pid,ruser|awk -v pid=$pid '{if($1==pid){print $2}}'` > /tmp/.360sduser
        kill -9 $pid
    fi

    for item in $m360sd_files; do
        pid=`pgrep -f "$InstallPath$item"`
        if [ ! -z "$pid" ]; then
            kill -9 $pid
        fi
    done
}

function_start_360sd()
{
    pid=`pgrep -f "start360sd_safed"`
    isok=${InstallPath}/.isok
    if [ -e "$isok" ]; then
    	if [ -z "$pid" ]; then
        	/usr/bin/start360sd_safed &
    	fi
    fi
    spid=`pgrep -f "\<start360sd\>"`
    if [ -e /tmp/.360sduser ] && [ -z "$spid" ]; then
        user=`cat /tmp/.360sduser`
        if [ ! -z "$user" ]; then
           ${InstallPath}/tools/start360sd_foruser $user 
        fi
	rm -rf /tmp/.360sduser
    fi
}



case $1 in
	stop)
		stop360sd
		;;
	start)
		function_start_360sd
		;;
        restart)
		stop360sd
		/usr/bin/start360sd_safed
                function_start_360sd
                ;;
	*)
		function_start_360sd
		;;
esac
