#!/bin/bash

#set -e
INSTALLROOTDIR="/opt/apps/com.360.epp/files"
m360sd_files="/360sdforcnos/360sd"
getSkyCenterAddress()
{
    ipport=`echo "$1" | awk '{start=match($0,"\(");end=match($0,"\)");len= end - start;print substr($0,start + 1,len - 1)}'`
    echo "$ipport"
}

addPrivateCloudServer()
{
    res=`sed '/<PrivateCloudServer>/c <PrivateCloudServer>'$1':'$2'<\/PrivateCloudServer>' "$INSTALLROOTDIR/etc/360sd/360sd.xml" | sed 's/^<PrivateCloudServer>/\t<PrivateCloudServer>/'`
    echo "$res" > "$INSTALLROOTDIR/etc/360sd/360sd.xml"
}


# set vmconfig.conf ip and port
config_vmconfig()
{
    sections=("\[SERVER_INFO\]")
    for part in ${sections[@]}
    do
        if [ -f $INSTALLROOTDIR/conf/vmconfig.conf ]; then
            ret=`grep -n ${part} $INSTALLROOTDIR/conf/vmconfig.conf | cut -d ":" -f 1`
            if [ ! -z '$ret' ]; then
                ip_lineno=`expr ${ret} + 1`
                port_lineno=`expr ${ret} + 2`
                sed -i ${ip_lineno}'s/.*/IP='$ip'/g' $INSTALLROOTDIR/conf/vmconfig.conf
                sed -i ${port_lineno}'s/.*/PORT='$port'/g' $INSTALLROOTDIR/conf/vmconfig.conf
            fi
        fi
    done
}

refresh_link()
{
    rm -rf /usr/bin/start360sd
    ln -s $INSTALLROOTDIR/start360sd.sh /usr/bin/start360sd
    rm -rf /usr/bin/start360sd_safed
    ln -s $INSTALLROOTDIR/start360sd_safed.sh /usr/bin/start360sd_safed

	if [ -f "$INSTALLROOTDIR/system/360sd_usrstart.desktop" ];then
    	cp -f $INSTALLROOTDIR/system/360sd_usrstart.desktop /usr/share/applications/
    fi
    if [ -f "$INSTALLROOTDIR/system/360sd_autostart.desktop" ];then
    	cp -f $INSTALLROOTDIR/system/360sd_autostart.desktop /etc/xdg/autostart/
    fi

    if [ -f "$INSTALLROOTDIR/system/com.qihoo.cnossd.conf" ];then
    	cp -f $INSTALLROOTDIR/system/com.qihoo.cnossd.conf /etc/dbus-1/system.d/
    fi
    if [ -f "$INSTALLROOTDIR/system/com.qihoo.cnossd.policy" ];then
    	cp -f $INSTALLROOTDIR/system/com.qihoo.cnossd.policy /usr/share/polkit-1/actions/
    fi
    if [ -f "$INSTALLROOTDIR/system/com.qihoo.cnossd.service" ];then
		cp -f $INSTALLROOTDIR/system/com.qihoo.cnossd.service /usr/share/dbus-1/system-services/
	fi
	if [ -f "$INSTALLROOTDIR/system/360epp.service" ];then
		cp -f $INSTALLROOTDIR/system/360epp.service /etc/systemd/system/
	fi
	if [ -f "$INSTALLROOTDIR/system/deepin-right-scan.desktop" ];then
		cp -f $INSTALLROOTDIR/system/deepin-right-scan.desktop /usr/share/deepin/dde-file-manager/oem-menuextensions/
	fi
	if [ -f "$INSTALLROOTDIR/system/eppcron" ];then
		cp -f $INSTALLROOTDIR/system/eppcron /etc/cron.d/
	fi
}

refresh_icon()
{
    #refresh icon
    if [ -x "/usr/lib/deepin-store/deepin-store-scan-hook" ]; then
    /usr/lib/deepin-store/deepin-store-scan-hook
    fi

    pamdir=`find /usr/lib /lib -name pam_unix.so`
    crackdir=`dirname $pamdir`
    cracklibdir=`dirname $crackdir`
    if [[ ! -f "$crackdir/pam_cracklib.so" ]] && [[ ! -L "$crackdir/pam_cracklib.so" ]];then
        ln -s $INSTALLROOTDIR/crack/pam_cracklib.so $crackdir/pam_cracklib.so
    fi
    if [[ ! -f "$cracklibdir/libcrack.so.2" ]] && [[ ! -L "$cracklibdir/libcrack.so.2" ]];then
        ln -s $INSTALLROOTDIR/crack/libcrack.so.2.9.0 $cracklibdir/libcrack.so.2
    fi
}

#chmod
change_file_mode()
{
    #EXENAME="s360sdforcnos"
    #SAFED="360safed"

    if [ ! -d $INSTALLROOTDIR/log/archive ]; then
	    mkdir -p $INSTALLROOTDIR/log/archive
    fi

    chmod 0755 $INSTALLROOTDIR
    #bin
    chmod 0555 $INSTALLROOTDIR/s360sdforcnos
    chmod 0555 $INSTALLROOTDIR/fileshredder
    chmod 0554 $INSTALLROOTDIR/360safed
    chmod 0644 $INSTALLROOTDIR/conf/netagentlog.conf
    chmod 0555 $INSTALLROOTDIR/reinforce.sh
    #img
    chmod 0755 $INSTALLROOTDIR/img
    chmod 0444 $INSTALLROOTDIR/img/*
    #engine
    #chmod 0755 $INSTALLROOTDIR/engine
    #if [ -f $INSTALLROOTDIR/engine/update.txt ]; then
        #chmod 444 $INSTALLROOTDIR/engine/update.txt
    #fi
    #if [ -f $INSTALLROOTDIR/engine/7z.so ]; then
        #chmod 400 $INSTALLROOTDIR/engine/7z.so
    #fi
    #if [ -f $INSTALLROOTDIR/engine/Rar29.so ]; then
        #chmod 400 $INSTALLROOTDIR/engine/Rar29.so
    #fi
    #if [ -d $INSTALLROOTDIR/engine/ave ]; then
        #chmod 755 $INSTALLROOTDIR/engine/ave
       #chmod 400 $INSTALLROOTDIR/engine/ave/*
    #fi
    #if [ -d $INSTALLROOTDIR/engine/ave/data ]; then
        #chmod 755 $INSTALLROOTDIR/engine/ave/data
        #chmod 400 $INSTALLROOTDIR/engine/ave/data/*
    #fi

    if [ -d $INSTALLROOTDIR/engine/qex ]; then
        chmod 755 $INSTALLROOTDIR/lib/qex
        chmod 400 $INSTALLROOTDIR/lib/qex/*
    fi
    if [ -d $INSTALLROOTDIR/engine/qex/data ]; then
        chmod 755 $INSTALLROOTDIR/lib/qex/data
        chmod 400 $INSTALLROOTDIR/lib/qex/data/*
    fi

    #if [ -d $INSTALLROOTDIR/engine/qvm ]; then
    #    chmod 755 $INSTALLROOTDIR/engine/qvm
    #    chmod 400 $INSTALLROOTDIR/engine/qvm/*
    #fi
    #if [ -d $INSTALLROOTDIR/engine/qvm/data ]; then
    #    chmod 755 $INSTALLROOTDIR/engine/qvm/data
    #    chmod 400 $INSTALLROOTDIR/engine/qvm/data/*
    #fi
    #if [ -d $INSTALLROOTDIR/engine/bd ]; then
    #    chmod 755 $INSTALLROOTDIR/engine/bd
    #    chmod 400 $INSTALLROOTDIR/engine/bd/*
    #fi
    #if [ -d $INSTALLROOTDIR/engine/bd/data ]; then
    #    chmod 755 $INSTALLROOTDIR/engine/bd/data
    #    chmod 400 $INSTALLROOTDIR/engine/bd/data/*
    #fi
    #license
    chmod 0555 $INSTALLROOTDIR/license
    chmod 0444 $INSTALLROOTDIR/license/*

    chmod 0755 $INSTALLROOTDIR/etc/360sd
	chmod 0755 $INSTALLROOTDIR/res
    chmod 0444 $INSTALLROOTDIR/etc/360sd/360sd.xml
    chmod 0644 $INSTALLROOTDIR/etc/360sd/magic.mgc
    chmod 0644 /etc/dbus-1/system.d/com.qihoo.cnossd.conf

    if [ -f "/usr/share/applications/360sd_usrstart.desktop" ];then
   		chmod 0644 /usr/share/applications/360sd_usrstart.desktop
   	fi
   	if [ -f "/etc/xdg/autostart/360sd_autostart.desktop" ];then
    	chmod 0644 /etc/xdg/autostart/360sd_autostart.desktop
    fi

    chmod +x $INSTALLROOTDIR/start360sd.sh
    chmod +x $INSTALLROOTDIR/start360sd_safed.sh

    chmod 0555 /usr/bin/start360sd
    chmod 0555 /usr/bin/start360sd_safed
    chmod 0644 /usr/share/polkit-1/actions/com.qihoo.cnossd.policy
    chmod 0644 /usr/share/dbus-1/system-services/com.qihoo.cnossd.service

    if [ -f /etc/systemd/system/360epp.service ];then
	    chmod a+x /etc/systemd/system/360epp.service
	    systemctl enable 360epp.service
    fi
}

#替换XML配置文件对应行 $1为源文件$2为目标文件$3为替换item
replace_copy_xml()
{
    line=`sed -n "/<$3>.*<\/$3>/p" $1`
    sed -i "/<$3>.*<\/$3>/c \ $line" $2
}


resotre_all_file()
{
	s360_tmp_path="/tmp/360tmp"

	if [ ! -e $s360_tmp_path ]
	then
		return
	fi
	replace_copy_xml "$s360_tmp_path/360sd/360sd.xml" "$INSTALLROOTDIR/etc/360sd/360sd.xml" "UpdateIpFromCenter"
	replace_copy_xml "$s360_tmp_path/360sd/360sd.xml" "$INSTALLROOTDIR/etc/360sd/360sd.xml" "CenterUrl"
	rm -rf $s360_tmp_path

	if [ "$INSTALLROOTDIR" = "/opt/360sdforcnos" ];then
		return
	fi

	if [ -d "/opt/360sdforcnos/db" ];then
		mv -f /opt/360sdforcnos/db $INSTALLROOTDIR/
	fi

	if [ -d "/opt/360sdforcnos/log" ];then
		mkdir -p $INSTALLROOTDIR/log
		mv -f /opt/360sdforcnos/log/* $INSTALLROOTDIR/log/
	fi

	if [ -d "/opt/360sdforcnos/.360sd_isolate" ];then
		mv -f /opt/360sdforcnos/.360sd_isolate $INSTALLROOTDIR/
		#新版本已作隔离区兼容，不需要保留旧目录
		#ln -s $INSTALLROOTDIR/.360sd_isolate /opt/360sdforcnos/.360sd_isolate
	fi

	if [ -e "/opt/360sdforcnos/etc/360sd/global.db" ];then
		mv -f /opt/360sdforcnos/etc/360sd/global.db $INSTALLROOTDIR/etc/360sd/global.db
	fi

	if [ -e "/opt/360sdforcnos/etc/360sd/policy" ];then
		mv -f /opt/360sdforcnos/etc/360sd/policy $INSTALLROOTDIR/etc/360sd/policy
	fi

        if [ -d "/opt/360sdforcnos" ];then
                rm -rf /opt/360sdforcnos
        fi
}

check_ipaddr()
{
	echo $1|grep "^[0-9]\{1,3\}\.\([0-9]\{1,3\}\.\)\{2\}[0-9]\{1,3\}$" > /dev/null;
	if [ $? -ne 0 ]
	then
		return 1
	fi
	ipaddr=$1
	a=`echo $ipaddr|awk -F . '{print $1}'`
	b=`echo $ipaddr|awk -F . '{print $2}'`
	c=`echo $ipaddr|awk -F . '{print $3}'`
	d=`echo $ipaddr|awk -F . '{print $4}'`
	for num in $a $b $c $d
	do
		if [ $num -gt 255 ] || [ $num -lt 0 ]
		then
			return 1
		fi
	done
	return 0
}

check_port()
{
	ret=`echo $1 | sed 's/[0-9]//g'`

	if [ -z $ret ];then
		if [[ $1 -gt 0 ]] && [[ $1 -le 65535  ]];then
			return 0
		else
			return 1
		fi
	else
		return 1
	fi
}


function ppid () {
	ps -p ${1:-$$} -o ppid=;
}

getSkyCenterAddress() {
	ipport=`echo "$1" | awk '{start=match($0,"\\\(");end=match($0,"\\\)");len= end - start;print substr($0,start + 1,len - 1)}'`
	echo "$ipport"
}

addPrivateCloudServer() {
	res=`sed '/<PrivateCloudServer>/c <PrivateCloudServer>'$1':'$2'<\/PrivateCloudServer>' "$INSTALLROOTDIR/etc/360sd/360sd.xml" | sed 's/^<PrivateCloudServer>/\t<PrivateCloudServer>/'`
	echo "$res" > "$INSTALLROOTDIR/etc/360sd/360sd.xml"
}

addCenterServer() {
	Prefix="wss:\/\/"
	Suffix="\/endpoint"
	res=`sed '/<CenterUrl>/c <CenterUrl>'$Prefix''$1':'$2''$Suffix'<\/CenterUrl>' "$INSTALLROOTDIR/etc/360sd/360sd.xml" | sed 's/^<CenterUrl>/\t<CenterUrl>/'`
	echo "$res" > "$INSTALLROOTDIR/etc/360sd/360sd.xml"
	res1=`sed '/<UpdateIpFromCenter>/c <UpdateIpFromCenter>http:\/\/'$1':''36080<\/UpdateIpFromCenter>' "$INSTALLROOTDIR/etc/360sd/360sd.xml" | sed 's/^<UpdateIpFromCenter>/\t<UpdateIpFromCenter>/'`
	echo "$res1" > "$INSTALLROOTDIR/etc/360sd/360sd.xml"
}
setCenterServer(){
	mount -t proc proc /proc 2>/dev/null
	pid=$$
	if [ -z $pid ]
	then
		exit 1
	fi
    pkgppid=`ps -p ${pid:-$$} -o ppid=`
    pkgpppid=`ps -p ${pkgppid:-$$} -o ppid=`
	pkgname=`ps h -ocmd $pkgpppid | awk '{for(i=1;i<=NF;i++) if($i~/360epp*/) print $i;}'`

	addr=`getSkyCenterAddress "$pkgname"`
	ip=`echo "$addr" | awk -F"_" '{print $1}'`
	port=`echo "$addr" | awk -F"_" '{print $2}'`
	if [[ -z $ip ]] || [[ -z $port ]];then
		echo "server addr is NULL"
	else
		check_ipaddr $ip
		if [ 0 -eq $? ];then
			check_port $port
			if [ 0 -eq $? ];then
				addCenterServer "$ip" "$port"
			fi
		fi
	fi
}
function_start_360sd()
{
	if [ -e /tmp/.360sduser ]; then
		user=`cat /tmp/.360sduser`
		/usr/bin/start360sd_safed
		rm -rf /tmp/.360sduser
		echo "rm /tmp/.360sduser"
		$INSTALLROOTDIR/tools/start360sd_foruser $user
	fi
}

pwdverify()
{
	sh $INSTALLROOTDIR/startverify.sh
	if [ $? -ne 0 ]; then
		exit 1
	fi
}

stop360sd()
{
    if [ -e "/etc/cron.d/eppcrontab" ]
	then
            echo "" > /etc/cron.d/eppcrontab
	fi

	pid=`pgrep -f "start360sd_safed"`
    if [ ! -z "$pid" ]; then
        kill -9 $pid
    fi

    pid=`pgrep -f "start360sd"`
    if [ ! -z "$pid" ]; then
    	echo `ps -eo pid,ruser|awk -v pid=$pid '{if($1==pid){print $2}}'` > /tmp/.360sduser
    	echo "******create /tmp/.360sduser"
        kill -9 $pid
    fi

    for item in $m360sd_files; do
        pid=`pgrep -f "$INSTALLROOTDIR$item"`
        if [ ! -z "$pid" ]; then
            kill -9 $pid
        fi
    done
}

remove_file_not_in_package()
{
        if [ -e "$INSTALLROOTDIR/etc/360sd/360sdforcnos.pid" ];then
            kill -9 `cat $INSTALLROOTDIR/etc/360sd/360sdforcnos.pid` 2>/dev/null
            echo $? >/dev/null
        fi
        #rc=`lsmod | grep "rk360" | xargs echo`
        #if [ -n "$rc" ];then
            #rmmod rk360 2>/dev/null 1>&2
            #rm -rf /etc/360safe/360safe.ko 2>/dev/null 1>&2
        #fi

       # rc=`lsmod | grep "immu" | xargs echo`
       # if [ -n "$rc" ];then
            #rmmod immu 2>/dev/null 1>&2
            #rm -rf /etc/360safe/immu.ko 2>/dev/null 1>&2
       # fi

    if [ -e "$INSTALLROOTDIR/etc/360safe" ]
    then
        chattr -R -i $INSTALLROOTDIR/etc/360safe 2>/dev/null 1>&2
    fi
	echo ""
    if [ -e "$INSTALLROOTDIR/etc/360sd" ];then
        chattr -R -i $INSTALLROOTDIR/etc/360sd 2>/dev/null 1>&2
    fi
	echo ""
    if [ -e "$INSTALLROOTDIR" ];then
        chattr -R -i $INSTALLROOTDIR 2>/dev/null 1>&2
    fi
	echo ""
}

uninstall_report()
{
    if [ -x "$INSTALLROOTDIR/360sd" ]
    then
        export LD_LIBRARY_PATH=$INSTALLROOTDIR/lib/depends/:$LD_LIBRARY_PATH
        $INSTALLROOTDIR/360safed uninstall
    fi
}
backup_all_files()
{
	s360_tmp_path="/tmp/360tmp"
	if [ -e $s360_tmp_path ]
	then
		rm -rf  $s360_tmp_path
	fi
	mkdir  -p  $s360_tmp_path/360sd

	#unalias  cp  > /dev/null  2>&1
	#cp -r /etc/360safe/watcher $s360_tmp_path/watcher
	cp -r $INSTALLROOTDIR/etc/360sd/360sd.xml  $s360_tmp_path/360sd/360sd.xml

}

case "$1" in 
    dpkg)
        case "$2" in
            install)
                echo "360epp install ..." >&2
                refresh_link
                refresh_icon
                change_file_mode
                #addPrivateCloudServer "$ip" "$port"
                #config_vmconfig
                resotre_all_file
                setCenterServer
                #crontab -u root /etc/cron.d/eppcrontab
                function_start_360sd
                exit 0
            ;;
            upgrade)
                echo "360epp upgrade ..." >&2
                #remove_file_not_in_package
				refresh_link
                stop360sd
                backup_all_files
                exit 0
            ;;
            deconfigure)
                echo "360epp deconfigure ..." >&2
                remove_file_not_in_package
                exit 0
            ;;
            uninstall)
                echo "360epp uninstall ..." >&2
                pwdverify
                stop360sd
                echo ""
                remove_file_not_in_package
                echo ""
                #uninstall_report
                exit 0
            ;;

            *)
                echo "pkgctl called with unknown argument \`$1'" >&2
                exit -1
            ;;
        esac
    ;;
    rpm)
        case "$2" in
            post)
                case "$3" in
                    1)
                        echo "360epp post:$3 ..." >&2
                        refresh_link
                        change_file_mode
                        resotre_all_file
                        setCenterServer
                        #crontab -u root /etc/cron.d/eppcrontab
                        function_start_360sd
                        #/usr/bin/start360sd_safed
                        exit 0
                    ;;
                    
                    *)
                        echo "360epp post:$3 ..." >&2
                        change_file_mode
                        resotre_all_file
                        setCenterServer
                        #crontab -u root /etc/cron.d/eppcrontab
                        #/usr/bin/start360sd_safed
                        exit 0
                    ;;
                esac
            ;;
            pre)
                case "$3" in
                    2)
                        echo "360epp pre:$3 ..." >&2
                        stop360sd
                        backup_all_files
                        exit 0
                    ;;

                    *)
                        echo "pkgctl called with argument preun \`$3'" >&2
                    ;;
                esac
            ;;
            preun)
                case "$3" in
                    0)
                        echo "360epp preun:$3 ..." >&2
                        if [ -e "$INSTALLROOTDIR/etc/360sd" ]
                        then
                            chattr -R -i $INSTALLROOTDIR/etc/360sd 2>/dev/null 1>&2
                        fi
                        stop360sd
                        exit 0
                    ;;
                    
                    *)
                        echo "pkgctl called with argument preun \`$3'" >&2
                    ;;
                esac
            ;;
            postun)
                case "$3" in
                    1)
                        echo "360epp postun:$3 ..." >&2
                        resotre_all_file
                        #/usr/bin/start360sd_safed
                        function_start_360sd
                        exit 0
                    ;;
                    0)
                        echo "360epp postun:$3 ..." >&2
                        exit 0
                    ;;                  
                    *)
                        echo "pkgctl called with argument postun \`$3'" >&2
                    ;;
                esac
            ;;
            triggerun)
                pwdverify
                if [ $? -ne 0 ]; then
                    pid=$$
                    rpmpid=`ps -p ${pid:-$$} -o ppid=`
                    rpmppid=`ps -p ${rpmpid:-$$} -o ppid=`
                    if [ -z $rpmppid ]
                    then
                        exit 1
                    fi
                    kill -9 $rpmppid
                    exit 1
                fi
                exit 0
            ;;

            *)
                echo "pkgctl called with unknown argument \`$1'" >&2
                exit -1
            ;;
        esac
    ;;
    *)
        echo "pkgctl called with unknown argument \`$1'" >&2
        exit -1
    ;;
esac
