#!/bin/bash
#
# Copyright (c) 2011 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# Let the wrapped binary know that it has been run through the wrapper.
export CHROME_WRAPPER="`readlink -f "$0"`"
export DBUS_FATAL_WARNINGS=0
HERE="`dirname "$CHROME_WRAPPER"`"

# We include some xdg utilities next to the binary, and we want to prefer them
# over the system versions when we know the system versions are very old. We
# detect whether the system xdg utilities are sufficiently new to be likely to
# work for us by looking for xdg-settings. If we find it, we leave $PATH alone,
# so that the system xdg utilities (including any distro patches) will be used.
#if ! which xdg-settings &> /dev/null; then
  # Old xdg utilities. Prepend $HERE to $PATH to use ours instead.
  #export PATH="$HERE:$PATH"
#else
  # Use system xdg utilities. But first create mimeapps.list if it doesn't
  # exist; some systems have bugs in xdg-mime that make it fail without it.
  #xdg_app_dir="${XDG_DATA_HOME:-$HOME/.local/share/applications}"
  #mkdir -p "$xdg_app_dir"
  #[ -f "$xdg_app_dir/mimeapps.list" ] || touch "$xdg_app_dir/mimeapps.list"
#fi

# Always use our versions of ffmpeg libs.
# This also makes RPMs find the compatibly-named library symlinks.
if [[ -n "$LD_LIBRARY_PATH" ]]; then
  LD_LIBRARY_PATH="$HERE:$HERE/lib:$HERE/lib/depends:$LD_LIBRARY_PATH"
else
  LD_LIBRARY_PATH="$HERE:$HERE/lib:$HERE/lib/depends"
fi
export LD_LIBRARY_PATH

if [ ! -e $HERE/etc/360sd/sd ]
then
  exit 0
fi

enpwd=`cat $HERE/etc/360sd/sd`
if [ -z "$enpwd" ]
then
  exit 0
fi

$HERE/s360sdforcnos uninstall >> /dev/null
if [ $? -ne 0 ]; then
    exit 1
fi
exit 0				
